#ifndef __SHAPE__
#define __SHAPE__
#include "mex.h"
#include "index.h"

/* Shape: dd has to be in increasing order.  Once a Shape struct is created
 * with shape_new, you'll have to fill in dd and ss yourself. */

typedef struct {
  int nn;
  int *dd;
  int *ss;
} Shape;

Shape shape_new(int num);
void shape_free(Shape shape);
Shape shape_copy(Shape shape);

Shape shape_readindex(Index ii, int *ss);
Index shape_writeindex(Shape shape);
Index shape_index(Shape shape);

Shape shape_readmxarray(const mxArray *marray);
mxArray *shape_writemxarray(Shape shape);
void shape_rewritemxarray(mxArray *marray, Shape shape);

int shape_numelem(Shape ii);
int shape_length(Shape ii);
bool shape_isempty(Shape ii);

bool shape_consistent(Shape ii, Shape jj);
bool shape_subshape(Shape ii, Shape jj);
Shape shape_trim(Shape ii);

Shape shape_union(Shape ii, Shape jj);
Shape shape_intersect(Shape ii, Shape jj);
Shape shape_diff(Shape ii, Shape jj);
Shape shape_xor(Shape ii, Shape jj);

Shape shape_indexdiff(Shape ii, Index jj);
Shape shape_indexintersect(Shape ii, Index jj);

Shape shape_asgn(Shape ii, Index jj, int * ss);
Shape shape_ref(Shape ii, Index jj);

#endif
