#ifndef __SHAPE_OP_INDEX2ARG__
#define __SHAPE_OP_INDEX2ARG__
#include "index.h"
#include "shape.h"

/* assumes existence of elemop_name */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  Shape oo, ii, jj;
  Index kk;
  int nn;
  if ( nrhs == 0) 
    mexErrMsgTxt("Need at least one argument.");
  if ( ! mxIsClass(prhs[0],"shape") )
    mexErrMsgTxt("First argument has to be a shape.");
  oo = shape_readmxarray(prhs[0]);
  for ( nn = 1 ; nn < nrhs ; nn ++ ) {
    ii = oo;
    if ( mxIsClass(prhs[nn],"shape") ) {
      jj = shape_readmxarray(prhs[nn]);
      if ( ! shape_consistent(ii,jj) ) 
        mexErrMsgTxt("Shapes inconsistent.");
      kk = shape_writeindex(jj);
      shape_free(jj);
    } else {
      kk = index_readmxarray(prhs[nn]);
    }
    oo = elemop_name(ii,kk);
    index_free(kk);
    shape_free(ii);
  }
  plhs[0] = mxDuplicateArray(prhs[0]);
  shape_rewritemxarray(plhs[0],oo); 
  shape_free(oo);
}

#endif
